#include <windows.h>
#include <scrnsave.h>
#include "resource.h"

#pragma comment(lib,"opengl32.lib")
#pragma comment(lib,"glu32.lib")
#pragma comment(lib,"scrnsave.lib")

#define WININI_SECTION	"GL_ScreenSaver"
#define WININI_KEY		"Size"
#define WININI_BUF_SIZE	3
#include "Draw.h"

BOOL WINAPI RegisterDialogClasses (HANDLE hInst)
{
	return TRUE;
}

BOOL WINAPI ScreenSaverConfigureDialog (HWND hDlg,UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			int  size;
			char s[WININI_BUF_SIZE];
			char cmb[10][5] = {"1/1","1/2","1/3","1/4","1/5","1/6","1/7","1/8","1/9","1/10"};
			
			for(int i=0;i<10;i++){
				SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)cmb[i]);
			}
			GetProfileString(WININI_SECTION, WININI_KEY, "1", s, WININI_BUF_SIZE);
			size = atoi(s);
			SendDlgItemMessage(hDlg,IDC_COMBO1, CB_SETCURSEL, size-1, 0);
		}
		return TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_BUTTON1:
			if(!WriteProfileString(WININI_SECTION, NULL, NULL)){
				MessageBox(hDlg,"ݒ폜ł܂",WININI_SECTION,MB_OK);
			}
			else{
				SendMessage(hDlg, WM_CLOSE, 0, 0);
				return 0;
			}
			return TRUE;

		case IDOK:
			{
				char s[WININI_BUF_SIZE];
				int size = 1 + SendDlgItemMessage(hDlg,IDC_COMBO1, CB_GETCURSEL, 0, 0);
				itoa(size, s, 10);
				if(!WriteProfileString(WININI_SECTION, WININI_KEY, s)){
					MessageBox(hDlg,"ݒ win.ini ɕۑł܂",WININI_SECTION,MB_OK);
				}
			}
			EndDialog(hDlg, TRUE);
			return TRUE;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return TRUE;
		}
		return FALSE;

	case WM_CLOSE:
		EndDialog (hDlg, FALSE);
		return TRUE;
	}
	return FALSE;
}

LONG WINAPI ScreenSaverProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:    // 
		if(!InitGL(hWnd)){
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return 0;
		}
		SetTimer(hWnd, 1, 50, NULL);
		return FALSE;

	case WM_TIMER:	   // ^C}[Cxg
		Draw_Main();
		return FALSE;

	case WM_CLOSE:	   // 
		KillTimer(hWnd, 1);
		DestroyWindow(hWnd);
		Term(hWnd);
		PostQuitMessage(0);
		return FALSE;
	}

	return DefScreenSaverProc (hWnd, uMsg, wParam,lParam);
}
